# grunt-appverse-sonar-version

> Set the sonar.provectVersion field to package.version value.

## Getting Started
This plugin requires Grunt.

If you haven't used [Grunt](http://gruntjs.com/) before, be sure to check out the [Getting Started](http://gruntjs.com/getting-started) guide, as it explains how to create a [Gruntfile](http://gruntjs.com/sample-gruntfile) as well as install and use Grunt plugins. Once you're familiar with that process, you may install this plugin with this command:

```shell
npm install grunt-appverse-sonar-version --save-dev
```

Once the plugin has been installed, it may be enabled inside your Gruntfile with this line of JavaScript:

```js
grunt.loadNpmTasks('grunt-appverse-sonar-version');
```

## The "sonarVersion" task

### Overview
In your project's Gruntfile, add a section named `sonarVersion` to the data object passed into `grunt.initConfig()`.

```js
grunt.initConfig({
  sonarVersion: {
    default: {
      options: {
        field: 'sonar.projectVersion'
      },
      src: 'sonar-project.properties',
      dest: 'sonar-project.properties'
    }   
})
```

### Using with grunt release

* [grunt release](https://github.com/geddski/grunt-release) configuration:

```js
options: {
      additionalFiles: ['bower.json'],
      bump: true, //default: true
      changelog: false, //default: false
      changelogText: '<%= version %>\n', //default: '### <%= version %> - <%= grunt.template.today("yyyy-mm-dd") %>\n'
      file: 'package.json', //default: package.json
      add: false, //default: true
      commit: false, //default: true
      tag: false, //default: true
      push: false, //default: true
      pushTags: false, //default: true
      npm: false, //default: true
      npmtag: false, //default: no tag,
      afterBump: ['sonarVersion'] // optional grunt tasks to run after file versions are bumped
  }
```

## License
Copyright (c) 2012 GFT Appverse, S.L., Sociedad Unipersonal.

This Source  Code Form  is subject to the  terms of  the Appverse Public License
Version 2.0  ("APL v2.0").  If a copy of  the APL  was not  distributed with this
file, You can obtain one at <http://appverse.org/legal/appverse-license/>.

Redistribution and use in  source and binary forms, with or without modification,
are permitted provided that the  conditions  of the  AppVerse Public License v2.0
are met.

THIS SOFTWARE IS PROVIDED BY THE  COPYRIGHT HOLDERS  AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS  OR IMPLIED WARRANTIES, INCLUDING, BUT  NOT LIMITED TO,   THE IMPLIED
WARRANTIES   OF  MERCHANTABILITY   AND   FITNESS   FOR A PARTICULAR  PURPOSE  ARE
DISCLAIMED. EXCEPT IN CASE OF WILLFUL MISCONDUCT OR GROSS NEGLIGENCE, IN NO EVENT
SHALL THE  COPYRIGHT OWNER  OR  CONTRIBUTORS  BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL,  SPECIAL,   EXEMPLARY,  OR CONSEQUENTIAL DAMAGES  (INCLUDING, BUT NOT
LIMITED TO,  PROCUREMENT OF SUBSTITUTE  GOODS OR SERVICES;  LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT(INCLUDING NEGLIGENCE OR OTHERWISE)
ARISING  IN  ANY WAY OUT  OF THE USE  OF THIS  SOFTWARE,  EVEN  IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.
